#ifndef __PILE_GENERIQUE
#define __PILE_GENERIQUE


/////////////////////////////////////////////////////////////////////
//
//				Dclaration d'une classe gnrique Pile
//
/////////////////////////////////////////////////////////////////////

template <class T>
class Pile
{
private :
	T *vecteur;			// pile sous forme de tableau
	int taille;			// taille max de la pile
	int sommet;			// indice de sommet

public :
	Pile(int);			// constructeur avec taille
	~Pile();			// destructeur

	int vide();			// pile vide ?
	T dernier();		// lment au sommet de la pile
	void empiler(T);	// empiler un lment au sommet de la pile
	void depiler();		// dpiler le dernier lment
	int getSommet();		// valeur du sommet de pile
};


/////////////////////////////////////////////////////////////////////
//
//				 Dfinition d'une classe gnrique Pile
//
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Constructeur de la classe gnrique Pile
/////////////////////////////////////////////////////////////////////
template <class T>
Pile<T>::Pile(int max)
{
	vecteur = new T[max];
	taille = max;
	sommet = -1;
}

/////////////////////////////////////////////////////////////////////
// Destructeur de la classe gnrique Pile
/////////////////////////////////////////////////////////////////////
template <class T>
Pile<T>::~Pile()
{
	delete vecteur;
}

/////////////////////////////////////////////////////////////////////
// Mthode empiler de la classe gnrique Pile
// -> incrmente le sommet de pile et 
// -> place l'lment transmis en paramtre en haut de la pile
/////////////////////////////////////////////////////////////////////
template <class T>
void Pile<T>::empiler(T element)
{
	sommet++;
	vecteur[sommet] = element;
}

/////////////////////////////////////////////////////////////////////
// Mthode depiler de la classe gnrique Pile
// -> dcrmente le sommet de pile
/////////////////////////////////////////////////////////////////////
template <class T>
void Pile<T>::depiler()
{
	sommet--;
}

/////////////////////////////////////////////////////////////////////
// Mthode dernier de la classe gnrique Pile
// -> retourne l'lment situ au somme de la pile
/////////////////////////////////////////////////////////////////////
template <class T>
T Pile<T>::dernier()
{
	return (vecteur[sommet]);
}

/////////////////////////////////////////////////////////////////////
// Mthode vide de la classe gnrique Pile
// -> indique si la pile est vide
/////////////////////////////////////////////////////////////////////
template <class T>
int Pile<T>::vide()
{
	return (sommet == -1);
}

/////////////////////////////////////////////////////////////////////
// Mthode getSommet de la classe gnrique Pile
// -> retourne la valeur du sommet de la pile
/////////////////////////////////////////////////////////////////////
template <class T>
int Pile<T>::getSommet()
{
	return (sommet);
}


#endif
